From b739dd8935499e833655be5d05a8002df07cc8e9 Mon Sep 17 00:00:00 2001
From: Christina Fu <cfu@redhat.com>
Date: Thu, 24 Mar 2016 16:23:05 -0700
Subject: [PATCH] Ticket #1006 Audit logging for TPS REST operations

---
 .../src/com/netscape/certsrv/logging/IAuditor.java |   3 +-
 .../com/netscape/cms/servlet/base/PKIService.java  |  15 ++
 .../org/dogtagpki/server/rest/AuditService.java    | 117 ++++++--
 base/server/cmsbundle/src/LogMessages.properties   |  55 +++-
 .../src/com/netscape/cmscore/logging/Auditor.java  |  19 +-
 base/tps/shared/conf/CS.cfg.in                     |   4 +-
 .../dogtagpki/server/tps/config/ConfigService.java |  30 ++-
 .../server/tps/rest/AuthenticatorService.java      | 187 ++++++++++---
 .../server/tps/rest/ConnectorService.java          | 180 ++++++++++---
 .../server/tps/rest/ProfileMappingService.java     | 157 +++++++++--
 .../dogtagpki/server/tps/rest/ProfileService.java  | 171 ++++++++++--
 .../dogtagpki/server/tps/rest/TokenService.java    | 297 +++++++++++++++++----
 12 files changed, 1028 insertions(+), 207 deletions(-)

diff --git a/base/common/src/com/netscape/certsrv/logging/IAuditor.java b/base/common/src/com/netscape/certsrv/logging/IAuditor.java
index a9362259633e29d33f5ae8fc3efc86628c9ebe35..89c03b838ca2e546224bfd2b3785c6684b59aeed 100644
--- a/base/common/src/com/netscape/certsrv/logging/IAuditor.java
+++ b/base/common/src/com/netscape/certsrv/logging/IAuditor.java
@@ -70,9 +70,10 @@ public interface IAuditor {
      * @return a delimited string of one or more delimited name/value pairs
      */
     public String getParamString(String scope, String type, String id, Map<String, String> params);
+    public String getParamString(StringBuilder paramsters, Map<String, String> params);
 
     /**
      * Log audit message.
      */
     public void log(String message);
-}
\ No newline at end of file
+}
diff --git a/base/server/cms/src/com/netscape/cms/servlet/base/PKIService.java b/base/server/cms/src/com/netscape/cms/servlet/base/PKIService.java
index d2e55b5a3c42ee89f5784da12de860fd4e8880bf..7ed9c0dc86b08add5066a9c6df29ce791775e54e 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/base/PKIService.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/base/PKIService.java
@@ -259,6 +259,21 @@ public class PKIService {
         auditor.log(auditMessage);
     }
 
+    public void auditConfigTokenGeneral(String status, String service, Map<String, String> params, String info) {
+        CMS.debug("PKIService.auditConfigTokenGeneral begins");
+
+        String msg = CMS.getLogMessage(
+                "LOGGING_SIGNED_AUDIT_CONFIG_TOKEN_GENERAL_5",
+                servletRequest.getUserPrincipal().getName(),
+                status,
+                service,
+                auditor.getParamString(null, params),
+                info);
+        auditor.log(msg);
+
+        CMS.debug("PKIService.auditConfigTokenGeneral ends");
+    }
+
     /**
      * Get the values of the fields annotated with @FormParam.
      */
diff --git a/base/server/cms/src/org/dogtagpki/server/rest/AuditService.java b/base/server/cms/src/org/dogtagpki/server/rest/AuditService.java
index e32c36c3313e8bbb3ea729245dcd51d5f2fda7a7..273625e81776ab8a8cd024f503f5e45ade94612a 100644
--- a/base/server/cms/src/org/dogtagpki/server/rest/AuditService.java
+++ b/base/server/cms/src/org/dogtagpki/server/rest/AuditService.java
@@ -21,6 +21,7 @@ package org.dogtagpki.server.rest;
 import java.io.UnsupportedEncodingException;
 import java.net.URI;
 import java.util.Collection;
+import java.util.HashMap;
 import java.util.Map;
 import java.util.TreeMap;
 import java.util.TreeSet;
@@ -42,6 +43,7 @@ import com.netscape.certsrv.base.IConfigStore;
 import com.netscape.certsrv.base.PKIException;
 import com.netscape.certsrv.logging.AuditConfig;
 import com.netscape.certsrv.logging.AuditResource;
+import com.netscape.certsrv.logging.ILogger;
 import com.netscape.cms.servlet.base.PKIService;
 
 /**
@@ -66,29 +68,62 @@ public class AuditService extends PKIService implements AuditResource {
     }
 
     public AuditConfig createAuditConfig() throws UnsupportedEncodingException, EBaseException {
+        return createAuditConfig(null);
+    }
+
+    public AuditConfig createAuditConfig(Map<String, String> auditParams)
+            throws UnsupportedEncodingException, EBaseException {
 
         IConfigStore cs = CMS.getConfigStore();
 
         AuditConfig auditConfig = new AuditConfig();
-        auditConfig.setStatus(cs.getBoolean("log.instance.SignedAudit.enable", false) ? "Enabled" : "Disabled");
-        auditConfig.setSigned(cs.getBoolean("log.instance.SignedAudit.logSigning", false));
-        auditConfig.setInterval(cs.getInteger("log.instance.SignedAudit.flushInterval", 5));
-        auditConfig.setBufferSize(cs.getInteger("log.instance.SignedAudit.bufferSize", 512));
+        String val = null;
+        Boolean boolval = false;
+        Integer integerval;
+
+        val = cs.getBoolean("log.instance.SignedAudit.enable", false) ? "Enabled" : "Disabled";
+        auditConfig.setStatus(val);
+        if (auditParams != null)
+            auditParams.put("enable", val);
+
+        boolval = cs.getBoolean("log.instance.SignedAudit.logSigning", false);
+        if (auditParams != null)
+            auditParams.put("logSigning", boolval ? "true" : "false");
+        auditConfig.setSigned(boolval);
+
+        integerval = cs.getInteger("log.instance.SignedAudit.flushInterval", 5);
+        auditConfig.setInterval(integerval);
+        if (auditParams != null)
+            auditParams.put("flushInterval", integerval.toString());
+
+        integerval = cs.getInteger("log.instance.SignedAudit.bufferSize", 512);
+        auditConfig.setBufferSize(integerval);
+        if (auditParams != null)
+            auditParams.put("bufferSize", integerval.toString());
 
         Map<String, String> eventConfigs = new TreeMap<String, String>();
 
         // unselected optional events
-        for (String event : StringUtils.split(cs.getString("log.instance.SignedAudit.unselected.events", ""), ", ")) {
+        val = cs.getString("log.instance.SignedAudit.unselected.events", "");
+        if (auditParams != null)
+            auditParams.put("unselected.events", val);
+        for (String event : StringUtils.split(val, ", ")) {
             eventConfigs.put(event.trim(), "disabled");
         }
 
         // selected optional events
-        for (String event : StringUtils.split(cs.getString("log.instance.SignedAudit.events", ""), ", ")) {
+        val = cs.getString("log.instance.SignedAudit.events", "");
+        if (auditParams != null)
+            auditParams.put("events", val);
+        for (String event : StringUtils.split(val, ", ")) {
             eventConfigs.put(event.trim(), "enabled");
         }
 
         // always selected mandatory events
-        for (String event : StringUtils.split(cs.getString("log.instance.SignedAudit.mandatory.events", ""), ", ")) {
+        val = cs.getString("log.instance.SignedAudit.mandatory.events", "");
+        if (auditParams != null)
+            auditParams.put("mandatory.events", val);
+        for (String event : StringUtils.split(val, ", ")) {
             eventConfigs.put(event.trim(), "mandatory");
         }
 
@@ -119,8 +154,14 @@ public class AuditService extends PKIService implements AuditResource {
 
     @Override
     public Response updateAuditConfig(AuditConfig auditConfig) {
+        Map<String, String> auditModParams = new HashMap<String, String>();
 
-        if (auditConfig == null) throw new BadRequestException("Audit config is null.");
+        if (auditConfig == null) {
+            BadRequestException e = new BadRequestException("Audit config is null.");
+            auditModParams.put("Info", e.toString());
+            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+            throw e;
+        }
 
         CMS.debug("AuditService.updateAuditConfig()");
 
@@ -157,20 +198,29 @@ public class AuditService extends PKIService implements AuditResource {
 
                     // make sure no event is added
                     if (currentValue == null) {
-                        throw new PKIException("Unable to add event: " + name);
+                        PKIException e = new PKIException("Unable to add event: " + name);
+                        auditModParams.put("Info", e.toString());
+                        auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                        throw e;
                     }
 
                     // make sure no optional event becomes mandatory
                     if ("mandatory".equals(value)) {
                         if (!"mandatory".equals(currentValue)) {
-                            throw new PKIException("Unable to add mandatory event: " + name);
+                            PKIException e = new PKIException("Unable to add mandatory event: " + name);
+                            auditModParams.put("Info", e.toString());
+                            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                            throw e;
                         }
                         continue;
                     }
 
                     // make sure no mandatory event becomes optional
                     if ("mandatory".equals(currentValue)) {
-                        throw new PKIException("Unable to remove mandatory event: " + name);
+                        PKIException e = new PKIException("Unable to remove mandatory event: " + name);
+                        auditModParams.put("Info", e.toString());
+                        auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                        throw e;
                     }
 
                     if ("enabled".equals(value)) {
@@ -180,7 +230,10 @@ public class AuditService extends PKIService implements AuditResource {
                         unselected.add(name);
 
                     } else {
-                        throw new PKIException("Invalid event configuration: " + name + "=" + value);
+                        PKIException e = new PKIException("Invalid event configuration: " + name + "=" + value);
+                        auditModParams.put("Info", e.toString());
+                        auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                        throw e;
                     }
                 }
 
@@ -191,20 +244,28 @@ public class AuditService extends PKIService implements AuditResource {
             for (String name : currentEventConfigs.keySet()) {
                 // make sure no event is removed
                 if (!eventConfigs.containsKey(name)) {
-                    throw new PKIException("Unable to remove event: " + name);
+                    PKIException e = new PKIException("Unable to remove event: " + name);
+                    auditModParams.put("Info", e.toString());
+                    auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                    throw e;
                 }
             }
 
             cs.commit(true);
 
-            auditConfig = createAuditConfig();
+            auditConfig = createAuditConfig(auditModParams);
+            auditTPSConfigSignedAudit(ILogger.SUCCESS, auditModParams);
 
             return createOKResponse(auditConfig);
 
         } catch (PKIException e) {
+            auditModParams.put("Info", e.toString());
+            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
             throw e;
 
         } catch (Exception e) {
+            auditModParams.put("Info", e.toString());
+            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
             e.printStackTrace();
             throw new PKIException(e.getMessage());
         }
@@ -212,10 +273,12 @@ public class AuditService extends PKIService implements AuditResource {
 
     @Override
     public Response changeAuditStatus(String action) {
+        Map<String, String> auditModParams = new HashMap<String, String>();
 
         CMS.debug("AuditService.changeAuditStatus()");
 
         try {
+            auditModParams.put("Action", action);
             IConfigStore cs = CMS.getConfigStore();
 
             if ("enable".equals(action)) {
@@ -225,21 +288,45 @@ public class AuditService extends PKIService implements AuditResource {
                 cs.putBoolean("log.instance.SignedAudit.enable", false);
 
             } else {
-                throw new BadRequestException("Invalid action " + action);
+                BadRequestException e = new BadRequestException("Invalid action " + action);
+                auditModParams.put("Info", e.toString());
+                auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+                throw e;
             }
 
             cs.commit(true);
 
             AuditConfig auditConfig = createAuditConfig();
+            auditTPSConfigSignedAudit(ILogger.SUCCESS, auditModParams);
 
             return createOKResponse(auditConfig);
 
         } catch (PKIException e) {
+            auditModParams.put("Info", e.toString());
+            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+            e.printStackTrace();
             throw e;
 
         } catch (Exception e) {
+            auditModParams.put("Info", e.toString());
+            auditTPSConfigSignedAudit(ILogger.FAILURE, auditModParams);
+            e.printStackTrace();
             e.printStackTrace();
             throw new PKIException(e.getMessage());
         }
     }
+
+    /*
+     * in case of failure, "info" should be in the params
+     */
+    public void auditTPSConfigSignedAudit(String status, Map<String, String> params) {
+
+        String msg = CMS.getLogMessage(
+                "LOGGING_SIGNED_AUDIT_CONFIG_SIGNED_AUDIT_3",
+                servletRequest.getUserPrincipal().getName(),
+                status,
+                auditor.getParamString(null, params));
+        auditor.log(msg);
+
+    }
 }
diff --git a/base/server/cmscore/src/com/netscape/cmscore/logging/Auditor.java b/base/server/cmscore/src/com/netscape/cmscore/logging/Auditor.java
index f0bcb5bee3b36c654889921f6fcc5b1d5046c44e..8c99e676cc4d8acab36e90b3748fb7d9db7984ec 100644
--- a/base/server/cmscore/src/com/netscape/cmscore/logging/Auditor.java
+++ b/base/server/cmscore/src/com/netscape/cmscore/logging/Auditor.java
@@ -95,7 +95,8 @@ public class Auditor implements IAuditor {
     public String getParamString(String scope, String type, String id, Map<String, String> params) {
 
         // if no signed audit object exists, bail
-        if (signedAuditLogger == null) return null;
+        if (signedAuditLogger == null)
+            return null;
         StringBuilder parameters = new StringBuilder();
 
         // always identify the scope of the request
@@ -124,16 +125,26 @@ public class Auditor implements IAuditor {
                     + SIGNED_AUDIT_NAME_VALUE_DELIMITER
                     + id);
         }
+        return getParamString(parameters, params);
+    }
 
-        if (params == null) return parameters.toString();
+    @Override
+    public String getParamString(StringBuilder parameters, Map<String, String> params) {
+
+        if (parameters == null) {
+            parameters = new StringBuilder();
+        }
+        if (params == null)
+            return parameters.toString();
 
         // identify any remaining request parameters
 
-        for (Map.Entry<String,String> entry : params.entrySet() ) {
+        for (Map.Entry<String, String> entry : params.entrySet()) {
             String name = entry.getKey();
 
             // skip "RULENAME" parameter
-            if (name.equals(SIGNED_AUDIT_RULENAME)) continue;
+            if (name.equals(SIGNED_AUDIT_RULENAME))
+                continue;
 
             parameters.append(SIGNED_AUDIT_NAME_VALUE_PAIRS_DELIMITER);
 
diff --git a/base/tps/src/org/dogtagpki/server/tps/config/ConfigService.java b/base/tps/src/org/dogtagpki/server/tps/config/ConfigService.java
index 6cd5e9f7d8be3229f6bb83ace5bb83b5990feab2..b0b4fd229a322e2ecbb959314ad737023a883745 100644
--- a/base/tps/src/org/dogtagpki/server/tps/config/ConfigService.java
+++ b/base/tps/src/org/dogtagpki/server/tps/config/ConfigService.java
@@ -20,6 +20,7 @@ package org.dogtagpki.server.tps.config;
 
 import java.io.UnsupportedEncodingException;
 import java.net.URI;
+import java.util.HashMap;
 import java.util.Map;
 
 import javax.servlet.http.HttpServletRequest;
@@ -34,6 +35,7 @@ import org.jboss.resteasy.plugins.providers.atom.Link;
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.BadRequestException;
 import com.netscape.certsrv.base.PKIException;
+import com.netscape.certsrv.logging.ILogger;
 import com.netscape.certsrv.tps.config.ConfigData;
 import com.netscape.certsrv.tps.config.ConfigResource;
 import com.netscape.cms.servlet.base.PKIService;
@@ -94,8 +96,15 @@ public class ConfigService extends PKIService implements ConfigResource {
 
     @Override
     public Response updateConfig(ConfigData configData) {
+        String method = "ConfigService.updateConfig";
+        Map<String, String> auditModParams = new HashMap<String, String>();
 
-        if (configData == null) throw new BadRequestException("Config data is null.");
+        if (configData == null) {
+            BadRequestException e = new BadRequestException("Config data is null.");
+            auditModParams.put("Info", e.toString());
+            auditConfigTokenGeneral(ILogger.FAILURE, method, auditModParams, e.toString());
+            throw e;
+        }
 
         CMS.debug("ConfigService.updateConfig()");
 
@@ -103,32 +112,41 @@ public class ConfigService extends PKIService implements ConfigResource {
             ConfigDatabase configDatabase = new ConfigDatabase();
             ConfigRecord configRecord = configDatabase.getRecord("Generals");
 
-            Map<String, String> properties = configData.getProperties();
-            if (properties != null) {
+            Map<String, String> newProperties = configData.getProperties();
+            if (newProperties != null) {
                 // validate new properties
-                configDatabase.validateProperties(configRecord, null, properties);
+                configDatabase.validateProperties(configRecord, null, newProperties);
 
                 // remove old properties
                 configDatabase.removeProperties(configRecord, null);
 
                 // add new properties
-                configDatabase.addProperties(configRecord, null, properties);
+                configDatabase.addProperties(configRecord, null, newProperties);
             }
 
             configDatabase.commit();
 
-            properties = configDatabase.getProperties(configRecord, null);
+            Map<String, String> properties = configDatabase.getProperties(configRecord, null);
             configData = createConfigData(properties);
 
+            auditConfigTokenGeneral(ILogger.SUCCESS, method,
+                    newProperties, null);
+
             return Response
                     .ok(configData)
                     .build();
 
         } catch (PKIException e) {
+            CMS.debug(method +": " + e);
+            auditConfigTokenGeneral(ILogger.FAILURE, method,
+                    auditModParams, e.toString());
             throw e;
 
         } catch (Exception e) {
             e.printStackTrace();
+            CMS.debug(method +": " + e);
+            auditConfigTokenGeneral(ILogger.FAILURE, method,
+                    auditModParams, e.toString());
             throw new PKIException(e.getMessage());
         }
     }
